/************************************************************************/
/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/
/************************************************************************/

/*
 * Filename       : TListCatalogQBIC.cpp
 * Description    : List QBIC catalog information
 *
 */

#include <iostream.h>
#include <stdio.h>                
#include <DKConstant.h>
#include <DKDatastoreQBIC.hpp>
#include <DKDatastoreDefQBIC.hpp>
#include <DKException.hpp>
#include <DKString.hpp>
#include <DKSequentialCollection.hpp>
#include <DKFeatureDefQBIC.hpp>
#include <DKServerDefQBIC.hpp>
#include <DKDatabaseDefQBIC.hpp>
#include <DKCatalogDefQBIC.hpp>
#include <DKEnvironment.hpp>

void main(int argc, char *argv[])
{
   cout << "begin..." << endl;

   // Indicate this is a Console Application on Windows NT/95 for error
   // message code page conversion to OEM code page. If this was a Windows
   // GUI (Graphic User Interface) Application this would not be necessary
   // because DK_SS_WINDOWS is the default.
   DKEnvironment::setSubSystem(DK_SS_CONSOLE);

    //-------------------------------------------------------------- 
    // Checking for input parameters
    //--------------------------------------------------------------   
    if (argc < 4)
    {
     cout<<"Usage: "<<endl;
     cout<<"  TListCatalogQBIC <qbicsrv> <userid> <pw>" << endl;
     return;
    }
    // ### get input parameters
    DKString qbicsrv = DKString(argv[1]);
    DKString userid = DKString(argv[2]);
    DKString pw = DKString(argv[3]);
    DKDatastoreQBIC dsQBIC; // must be outside try/catch block

   try {
      
      DKSequentialCollection *pCol = 0;
      dkIterator *pIter = 0;
      DKSequentialCollection *pCol2 = 0;
      dkIterator *pIter2 = 0;
      DKSequentialCollection *pCol3 = 0;
      dkIterator *pIter3 = 0;
      DKServerDefQBIC *pSV = 0;
      DKDatabaseDefQBIC *pEntDB = 0;
      DKCatalogDefQBIC *pEntCat = 0;
      DKString strServerName;
      DKString strCatName;
      DKString strDBName;
      DKString strFeatName;
      DKFeatureDefQBIC *pAttr = 0;
      DKAny a;
      DKAny *pA = 0;
      long i = 0;
      long j = 0;
      long k = 0;
      cout << "list servers" << endl;
      a = dsQBIC.listDataSources();
      pCol = (DKSequentialCollection*)((dkCollection*)a);
      pIter = pCol->createIterator();
      while (pIter->more() == TRUE)
      {
       i++;
       pSV = (DKServerDefQBIC*)((void*)(*pIter->next()));
       strServerName = pSV->getName();
       cout << "Server Name [" << i << "] - " << strServerName << endl; 
       delete pSV;
      }
      delete pIter;
      delete pCol;
      cout << i << " servers listed" << endl;
      cout << "connecting to datastore" << endl;
      dsQBIC.connect(qbicsrv,userid,pw);
      cout << "datastore connected " << qbicsrv << " userid - " << userid << endl;
      cout << "list databases " << endl;
      pCol = (DKSequentialCollection*)((dkCollection*)dsQBIC.listEntities());
      pIter = pCol->createIterator();
      i = 0;
      while (pIter->more() == TRUE)
      {
       i++;
       pEntDB = (DKDatabaseDefQBIC*)((void*)(*pIter->next()));
       strDBName = pEntDB->getName();
       cout << "database name [" << i << "] - " << strDBName << endl;
       cout << "  list catalogs for DB " << strDBName << endl;
       pCol2 = (DKSequentialCollection*)((dkCollection*)pEntDB->listSubEntities());
       pIter2 = pCol2->createIterator();
       j = 0;
       while (pIter2->more() == TRUE)
       {
        j++;
        pA = pIter2->next();
        pEntCat = (DKCatalogDefQBIC*) pA->value();
        strCatName = pEntCat->getName();
        cout << "catalog name [" << j << "] - " << strCatName << endl;
        pCol3 = (DKSequentialCollection*)((dkCollection*)pEntCat->listAttrs());
        pIter3 = pCol3->createIterator();
        k = 0;
        while (pIter3->more() == TRUE)
        {
         k++;
         pA = pIter3->next();
         pAttr = (DKFeatureDefQBIC*) pA->value();
         cout << "    Attribute name [" << k << "] - " << pAttr->getName() << endl;
         cout << "      datastoreName " << pAttr->datastoreName() << endl;
         cout << "      datastoreType " << pAttr->datastoreType() << endl;
         cout << "      attributeOf   " << pAttr->getEntityName() << endl;
         delete pAttr;
	}
        delete pIter3;
        delete pCol3;
        delete pEntCat;
       }
       cout << "  " << j << " features listed for catalog: " << strCatName << endl;
       delete pIter2;
       delete pCol2;
       delete pEntDB;
      }
      delete pIter;
      delete pCol;
      cout << i << " databases listed" << endl;
      dsQBIC.disconnect();
      cout << "datastore disconnected" << endl;
   }
   catch(DKException &exc)
   {
      cout << "Error id " << exc.errorId() << endl;
      for(unsigned long i = 0; i< exc.textCount();i++)
      {
         cout << "Error text: " << exc.text(i) << endl;
      }
      for (unsigned long g=0; g< exc.locationCount();g++)
      {
         const DKExceptionLocation* p = exc.locationAtIndex(g);
         cout << "Filename: " << p->fileName() << endl;
         cout << "Function: " << p->functionName() << endl;
         cout << "LineNumber: " << p->lineNumber() << endl;
      }

      cout << "Exception Class Name: " << exc.name() << endl;
   }
   
   cout << "done ..." << endl;
   
}
