// TConnectDD.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
//#include "TConnectDD.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include "DKDatastoreDD.hpp"   // Added by DF to generated Source
#include "DKException.hpp"

/////////////////////////////////////////////////////////////////////////////
// The one and only application object

CWinApp theApp;

//using namespace std;

int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
	int nRetCode = 0;
	// initialize MFC and print and error on failure
	if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0))
	{
		// TODO: change error code to suit your needs
		cerr << _T("Fatal Error: MFC initialization failed") << endl;
		nRetCode = 1;
		return nRetCode;
	}

	// Begin coded added by DF

	for( int nbrArgs = 1; nbrArgs < argc; nbrArgs++ )
	{
		cout << "TConnectDD parm " << nbrArgs << "= "<< argv[nbrArgs] << endl;
    }
	if( nbrArgs < 4 )
	{
		cout << "TConnectDD usage = <serverName> <userId> <pw>" << endl;
		return -1;
	}

   DKDatastoreDD* dd;
   for(int i = 0; i < 2; i++ )
   {  
    try
    {
	  DKString server = argv[1];
	  DKString uid = argv[2];
	  DKString pw = argv[3];
      dd = new DKDatastoreDD();
	  cout <<" About to connect to dd backend datastore" << endl;
      dd->connect(server, uid, pw,"");
	  cout <<" Connected to dd backend datastore" << endl;

	  if( dd->isConnected() )
	  {
		  cout << "TConnectDD SUCCESS. Connected." << endl;
		  cout << "  UserId        = " << dd->userName() << endl;
		  cout << "  LibraryName   = " << dd->getLibraryName() << endl;
		  cout << "  DatastoreType = " << dd->datastoreType() << endl;
		  cout << "  DatastoreName = " << dd->datastoreName() << endl;
	  }
	  else
	  {
		  cout << "TConnectDD FAILURE. Did not connect." << endl;
		  cout << "  UserId     = " << dd->userName() << endl;	
		  cout << "  ServerName = " << dd->datastoreName() << endl;
	  }

	  dd->disconnect();
	  if( !dd->isConnected() )
	  {
		  cout << "TConnectDD SUCCESS.  Disconnected." << endl;
	  }
	  else
	  {
		  cout << "TConnectDD FAILED! Still connected after disconnect!" << endl;
	  }
	}
	catch( DKException dke )
	{
		for( long i = 0; i < dke.textCount(); i++ )
		{
		  const char* text = dke.text(i);
		  if( text != 0 )
		    cout << text << endl;
		}
	}
	catch( ... )
	{
		cout << "TConnectDD FAILURE! Caught unexpected exception." << endl;
	}
   }

   // End Code added by DF

	return nRetCode;
}


