/*
 * @copyright(disclaimer) 
 * Licensed Materials - Property of IBM
 * IBM  Enterprise Information Portal  for Multiplatforms V8.1  (program number 5724-B43)
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.
 * 
 * US Government Users Restricted Rights                                  
 *  Use, duplication or disclosure restricted by GSA ADP Schedule          
 *  Contract with IBM Corp.     
 * 
 * DISCLAIMER OF WARRANTIES :                                             
 *                                                                        
 * Permission is granted to copy and modify this  Sample code, and to           
 * distribute modified versions provided that both the copyright        
 * notice,- and this permission notice and warranty disclaimer  appear in all copies and modified  
 * versions. 
 * 
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS. 
 * IBM  AND ITS SUPPLIERS AND LICENSORS  DISCLAIM     
 * ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, IN 
 * SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF 
 * NON-INFRINGEMENT AND THE IMPLIED WARRANTIES 
 * OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR 
 * PURPOSE. IN NO EVENT WILL IBM OR ITS LICENSORS OR
 * SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT 
 * OF THE USE OF  OR INABILITY TO USE THE SAMPLE CODE, 
 * DISTRIBUTION OF THE SAMPLE CODE, OR COMBINATION 
 * OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO 
 * EVENT SHALL IBM OR ITS LICENSORS AND SUPPLIERS BE 
 * LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, 
 * OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,
 * INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED 
 * AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF 
 * IBM OR ITS LICENSORS OR SUPPLIERS HAVE BEEN ADVISED 
 * OF THE POSSIBILITY OF SUCH DAMAGES.                                     
 *                                                                  
 * @endCopyright
 */

/**
 * Creates the function bar
 *
 */
 import java.awt.*;
 import java.awt.event.*;
 import java.util.*;
 import javax.swing.*;
 import javax.swing.event.*;
 import javax.swing.text.*;
 import javax.swing.border.*;
 import com.ibm.mm.beans.gui.*;
 import com.ibm.mm.beans.*;


public class FunctionBar extends BannerToolBar implements
   CMBDocumentOpenedListener,
   CMBDocumentOpenFailedListener,
   CMBEntitySelectedListener,
   CMBLogonCompletedListener,
   CMBSearchCompletedListener,
   CMBSearchResultsListener,
   CMBSearchStartedListener,
   CMBTemplateSelectedListener,
   CMBViewDocumentListener
   {

  // Do not remove - needed for copyright protection
  private static String COPYRIGHT = ClientPane.IBM_LONG_COPYRIGHT;

  private boolean ltr = ClientPane.isLeftToRight();
  // this button is temp, remove after testing
  private JButton testButton=null;
  // end temp, test for

  private JButton cancelSearchButton=null;
  private JButton clearButton=null;
  private JButton searchButton=null;
  private JButton resetDefaultsButton=null;
  private JButton refreshTemplatesButton=null;
  private JButton helpButton=null;
  private JButton optionsButton=null;
  private CMBSearchTemplateViewer searchTemplateViewer=null;
  private CMBSearchTemplateList searchTemplateList=null;
  private CMBSearchPanel searchPanel = null;
  private CMBSearchResultsViewer searchResultsViewer= null;
  private CMBDocumentViewer documentViewer= null;
  private CMBConnection connection=null;
  private JLabel statusBar= null;
  private ClientInterface client = null;
  private ClientPane clientPane= null;
  private OptionsDialog optionsDialog= null;
  private transient int numberOfSearchResults=0;
  private Vector allDocumentsSelectedForViewing=new Vector();
  //private boolean templatesSupported = false;

public FunctionBar(ClientInterface aClientInterface,
                   ClientPane aClientPane) {
   super();
   client = aClientInterface;
   clientPane = aClientPane;
   // add logon listener to determine
   documentViewer=clientPane.getDocumentViewerBean();
   searchTemplateViewer=clientPane.getSearchTemplateViewerBean();
   searchTemplateList=clientPane.getSearchTemplateListBean();
   searchPanel= clientPane.getSearchPanelBean();
   searchResultsViewer=clientPane.getSearchResultsViewerBean();
   statusBar=clientPane.getStatusBar();
   connection=clientPane.getConnectionBean();


        // Load banner image
        //Image bannerImage = CMBUtil.getImage("banner.gif");
        // set banner image
        //setProductBanner(bannerImage);
        // Create gradient color
        Color gradColor = new Color(153, 162,177);
        setGradientColor(gradColor);
    clientPane.getLogonPanelBean().addLogonCompletedListener(this);
   //searchTemplateList.addTemplateSelectedListener(searchResultsViewer);
   searchTemplateList.addTemplateSelectedListener(this);
   searchTemplateViewer.addSearchResultsListener(this);
   searchTemplateViewer.addSearchStartedListener(this);
   searchTemplateViewer.addSearchCompletedListener(this);
   searchPanel.addEntitySelectedListener(this);
   searchPanel.addSearchResultsListener(this);
   searchPanel.addSearchStartedListener(this);
   searchPanel.addSearchCompletedListener(this);
   searchResultsViewer.addViewDocumentListener(this);
   documentViewer.addDocumentOpenedListener(this);
   documentViewer.addDocumentOpenFailedListener(this);
   functionBarSetup();

}

private void functionBarSetup(){
   loadButtons();
   //setBorder(BorderFactory.createEmptyBorder());
  }
  
  public void addNotify() {
    super.addNotify();
    // Fix the size of the options button
    Dimension size1 = refreshTemplatesButton.getSize();
    Dimension size2 = optionsButton.getPreferredSize();
    optionsButton.setPreferredSize(size1);
    optionsButton.setMinimumSize(size1);
    //int widthdiff = size1.width - size2.width;
    //int heightdiff = size1.height - size2.height;
    //optionsButton.setMargin(new Insets(1 + heightdiff/2, 1 + widthdiff/2, 1 + heightdiff/2, 1 + widthdiff/2));
  }

private void loadButtons() {
    
    setBorderPainted(true);
    setMargin(new Insets(10,5,5,5));
    
    java.net.URL url;
    
    // Search button   
    url = ResourceMgr.getImageURL("SEARCH");
    System.out.println("URL: " + url);
    Image image = ResourceMgr.getImage(url);
    ImageIcon nIcon = new ImageIcon(image);
    //ImageIcon nIcon = (ImageIcon)new RoundIcon(RoundIcon.State.NORMAL,image);
    //ImageIcon rIcon = (ImageIcon)(new RoundIcon(RoundIcon.State.ROLLOVER, image));
    //ImageIcon pIcon = (ImageIcon)(new RoundIcon(RoundIcon.State.PRESSED, image));
    //Image disabledImage = GrayFilter.createDisabledImage(nIcon.getImage());
    //ImageIcon dIcon = (ImageIcon)(new RoundIcon(RoundIcon.State.PRESSED, disabledImage));
   
   searchButton = new JButton(nIcon);
   //searchButton.setIcon(nIcon);
   //searchButton.setRolloverIcon(rIcon);
   //searchButton.setPressedIcon(pIcon);
   //searchButton.setDisabledIcon(dIcon);
   //searchButton.setRolloverEnabled(true);
   searchButton.addActionListener(new ActionListener() {
                            public void actionPerformed(ActionEvent e) {
                                search();
                            }
   });
   searchButton.setMargin(new Insets(5,2,2,2));
   //searchButton.setBorder(BorderFactory.createEmptyBorder());
   
   url = ResourceMgr.getImageURL("STOP");
   image = ResourceMgr.getImage(url);
   nIcon = new ImageIcon(image);
   //rIcon = (ImageIcon)(new RoundIcon(RoundIcon.State.ROLLOVER, image));
   //pIcon = (ImageIcon)(new RoundIcon(RoundIcon.State.PRESSED, image));
   //disabledImage = GrayFilter.createDisabledImage(nIcon.getImage());
   //dIcon = (ImageIcon)(new RoundIcon(RoundIcon.State.PRESSED, disabledImage));
   
   cancelSearchButton = new JButton(nIcon);
   //cancelSearchButton.setIcon(nIcon);
   //cancelSearchButton.setRolloverIcon(rIcon);
   //cancelSearchButton.setPressedIcon(pIcon);
   //cancelSearchButton.setDisabledIcon(dIcon);
   //cancelSearchButton.setRolloverEnabled(true);
   cancelSearchButton.addActionListener(new ActionListener() {
                            public void actionPerformed(ActionEvent e) {
                                cancelSearch();
                            }
   });
   cancelSearchButton.setMargin(new Insets(2,2,2,2));
   //cancelSearchButton.setBorder(BorderFactory.createEmptyBorder());
   
   url = ResourceMgr.getImageURL("CLEAR_SEARCH");
   image = ResourceMgr.getImage(url);
   nIcon = new ImageIcon(image);
   //nIcon = (ImageIcon)new RoundIcon(RoundIcon.State.NORMAL,image);
   //rIcon = (ImageIcon)(new RoundIcon(RoundIcon.State.ROLLOVER, image));
   //pIcon = (ImageIcon)(new RoundIcon(RoundIcon.State.PRESSED, image));
   //disabledImage = GrayFilter.createDisabledImage(nIcon.getImage());
   //dIcon = (ImageIcon)(new RoundIcon(RoundIcon.State.PRESSED, disabledImage));
   
   clearButton = new JButton(nIcon);
   //clearButton.setIcon(nIcon);
   //clearButton.setRolloverIcon(rIcon);
   //clearButton.setPressedIcon(pIcon);
   //clearButton.setDisabledIcon(dIcon);
   //clearButton.setRolloverEnabled(true);
   clearButton.addActionListener(new ActionListener() {
                            public void actionPerformed(ActionEvent e) {
                                clear();
                            }
   });
   //clearButton.setMargin(new Insets(0,0,0,0));
   //clearButton.setBorder(BorderFactory.createEmptyBorder());
   
   url = ResourceMgr.getImageURL("RESET_DEFAULTS");
   image = ResourceMgr.getImage(url);
   nIcon = new ImageIcon(image);
   //nIcon = (ImageIcon)new RoundIcon(RoundIcon.State.NORMAL,image);
   //rIcon = (ImageIcon)(new RoundIcon(RoundIcon.State.ROLLOVER, image));
   //pIcon = (ImageIcon)(new RoundIcon(RoundIcon.State.PRESSED, image));
   //disabledImage = GrayFilter.createDisabledImage(nIcon.getImage());
   //dIcon = (ImageIcon)(new RoundIcon(RoundIcon.State.PRESSED, disabledImage));
   
   resetDefaultsButton = new JButton(nIcon);
   //resetDefaultsButton.setIcon(nIcon);
   //resetDefaultsButton.setRolloverIcon(rIcon);
   //resetDefaultsButton.setPressedIcon(pIcon);
   //resetDefaultsButton.setDisabledIcon(dIcon);
   //resetDefaultsButton.setRolloverEnabled(true);
   resetDefaultsButton.addActionListener(new ActionListener() {
                            public void actionPerformed(ActionEvent e) {
                                resetDefaults();
                            }
   });
   resetDefaultsButton.setMargin(new Insets(2,2,2,2));
   //resetDefaultsButton.setBorder(BorderFactory.createEmptyBorder());
   
   // Options button
   url = ResourceMgr.getImageURL("OPTIONS");
   image = ResourceMgr.getImage(url);
   nIcon = new ImageIcon(image);
   //nIcon = (ImageIcon)new RoundIcon(RoundIcon.State.NORMAL,image);
   //rIcon = (ImageIcon)(new RoundIcon(RoundIcon.State.ROLLOVER, image));
   //pIcon = (ImageIcon)(new RoundIcon(RoundIcon.State.PRESSED, image));
   //disabledImage = GrayFilter.createDisabledImage(image);
   //dIcon = (ImageIcon)(new RoundIcon(RoundIcon.State.PRESSED, disabledImage));
   
   optionsButton = new JButton(nIcon);
   //optionsButton.setIcon(nIcon);
   //optionsButton.setRolloverIcon(rIcon);
   //optionsButton.setPressedIcon(pIcon);
   //optionsButton.setDisabledIcon(dIcon);
   //optionsButton.setRolloverEnabled(true);
   optionsButton.addActionListener(new ActionListener() {
                            public void actionPerformed(ActionEvent e) {
                                showOptionsDialog();
                            }
   });
   optionsButton.setMargin(new Insets(2,2,2,2));
   //optionsButton.setBorder(BorderFactory.createEmptyBorder());
   
   url = ResourceMgr.getImageURL("REFRESH_TEMPLATES");
   image = ResourceMgr.getImage(url);
   nIcon = new ImageIcon(image);
   //nIcon = (ImageIcon)new RoundIcon(RoundIcon.State.NORMAL,image);
   //rIcon = (ImageIcon)(new RoundIcon(RoundIcon.State.ROLLOVER, image));
   //pIcon = (ImageIcon)(new RoundIcon(RoundIcon.State.PRESSED, image));
   //disabledImage = GrayFilter.createDisabledImage(nIcon.getImage());
   //dIcon = (ImageIcon)(new RoundIcon(RoundIcon.State.PRESSED, disabledImage));
   
   refreshTemplatesButton = new JButton(nIcon);
   //refreshTemplatesButton.setIcon(nIcon);
   //refreshTemplatesButton.setRolloverIcon(rIcon);
   //refreshTemplatesButton.setPressedIcon(pIcon);
   //refreshTemplatesButton.setDisabledIcon(dIcon);
   //refreshTemplatesButton.setRolloverEnabled(true);
   refreshTemplatesButton.addActionListener(new ActionListener() {
                            public void actionPerformed(ActionEvent e) {
                                refreshTemplates();
                            }
   });
   refreshTemplatesButton.setMargin(new Insets(2,2,2,2));
   //refreshTemplatesButton.setBorder(BorderFactory.createEmptyBorder());
   
   url = ResourceMgr.getImageURL("HELP");
   image = ResourceMgr.getImage(url);
   nIcon = new ImageIcon(image);
   //nIcon = (ImageIcon)new RoundIcon(RoundIcon.State.NORMAL,image);
   //rIcon = (ImageIcon)(new RoundIcon(RoundIcon.State.ROLLOVER, image));
   //pIcon = (ImageIcon)(new RoundIcon(RoundIcon.State.PRESSED, image));
   //disabledImage = GrayFilter.createDisabledImage(nIcon.getImage());
   //dIcon = (ImageIcon)(new RoundIcon(RoundIcon.State.PRESSED, disabledImage));
   
   helpButton = new JButton(nIcon);
   //helpButton.setIcon(nIcon);
   //helpButton.setRolloverIcon(rIcon);
   //helpButton.setPressedIcon(pIcon);
   //helpButton.setDisabledIcon(dIcon);
   //helpButton.setRolloverEnabled(true);
   helpButton.addActionListener(new ActionListener() {
                            public void actionPerformed(ActionEvent e) {
                                showHelp();
                            }
   });
   helpButton.setMargin(new Insets(2,2,2,2));
   //helpButton.setBorder(BorderFactory.createEmptyBorder());

   if (ltr) {
        add(searchButton);
        add(cancelSearchButton);
        add(clearButton);
        add(resetDefaultsButton);
        addSeparator();
        add(optionsButton);
        add(refreshTemplatesButton);
        addSeparator();
        add(helpButton);
    
   } 
   // BiDi language - add in reverse order
   else {
        setComponentOrientation(ComponentOrientation.RIGHT_TO_LEFT);
        add(helpButton);
        addSeparator();
        add(refreshTemplatesButton);
        add(optionsButton);
        addSeparator();
        add(resetDefaultsButton);
        add(clearButton);
        add(cancelSearchButton);
        add(searchButton);
   }
   
   // Set tool tip text
   searchButton.setToolTipText(ResourceMgr.getString( "START_SEARCH"));
   cancelSearchButton.setToolTipText(ResourceMgr.getString( "CANCEL_SEARCH"));
   clearButton.setToolTipText(ResourceMgr.getString( "CLEAR_SEARCH_FIELDS"));
   resetDefaultsButton.setToolTipText(ResourceMgr.getString( "RESET_DEFAULT_SEARCH_VALUES"));
   optionsButton.setToolTipText(ResourceMgr.getString( "OPTIONS"));
   refreshTemplatesButton.setToolTipText(ResourceMgr.getString( "REFRESH_TEMPLATES"));
   helpButton.setToolTipText(ResourceMgr.getString( "HELP"));
   
   // Set the margins for the buttons
   searchButton.setMargin(new Insets(1,1,1,1));
   cancelSearchButton.setMargin(new Insets(1,1,1,1));
   clearButton.setMargin(new Insets(1,1,1,1));
   resetDefaultsButton.setMargin(new Insets(1,1,1,1));
   optionsButton.setMargin(new Insets(1,1,1,1));
   refreshTemplatesButton.setMargin(new Insets(1,1,1,1));
   helpButton.setMargin(new Insets(1,1,1,1));
   
}

    
private void clear() {
    try {
        if (clientPane.isTemplatesSupported())
            searchTemplateViewer.clear();// for current st clear sc
        else 
            searchPanel.clear();
    } catch (java.lang.RuntimeException e) {
        // ignore
    }
    searchResultsViewer.clear();// for current st clear sr
    enableButtons();
	cmbValidate();
}

private void showOptionsDialog() {
    //JDialog d=optionsDialog.getDialog(client.getMainFrame());
    if (optionsDialog == null) {
        optionsDialog = new OptionsDialog(clientPane);
    }
    optionsDialog.show();
    cmbValidate();
}
    
// reset to defaults is a deep reset. For all Search Templates, reset
// the search criteria viewers to default values.
// Clear all SRViewers for all ST's.
private void resetDefaults() {
    if (clientPane.isTemplatesSupported()) 
        searchTemplateViewer.deepReset(); //  reset all SCViewers to defaults
    else 
        searchPanel.deepReset();        // reset all entities to defaults
    searchResultsViewer.deepClear(); //  clear all SRViewers
    enableButtons();
    cmbValidate();
}

private void refreshTemplates() {
    if (!clientPane.isTemplatesSupported()) return;
    disableButtons();
    paintImmediately(getVisibleRect());
    (connection.getSchemaManagement()).clearSchemaCache();
    searchTemplateViewer.refresh();
    searchResultsViewer.refresh();
    searchTemplateList.refresh();
    try {
      searchTemplateList.setSelectedTemplateIndex(0);
      //System.out.println(" selected template is " + searchTemplateList.getSelectedTemplate());
    } catch (Exception ex) {
       //System.out.println(" selected template " + searchTemplateList.getSelectedTemplate());
       System.out.println(" There are no templates defined for this user.");
    }
    enableButtons();
    verifyButtonStates();
    cmbValidate();
}

private void cancelSearch() {
    if (clientPane.isTemplatesSupported() && searchTemplateViewer.isSearchInProgress())
        searchTemplateViewer.cancelSearch();
    if (!clientPane.isTemplatesSupported() && searchPanel.isSearchInProgress())
        searchPanel.cancelSearch();
    MessageBox mb = new MessageBox(JOptionPane.getFrameForComponent(this), ResourceMgr.getString( "TITLEBAR_TITLE"),ResourceMgr.getString( "SEARCH_CANCELED"),50,null);
    searchIsDone();
}

/* when the search starts we will listen for onSearchStarted event*/
/* it is in the onSearchStarted method that we flip the buttons etc*/
private void search() {
    System.out.println("About to run a search. The maximum number of results to be returned is: " + searchTemplateViewer.getMaxResults());
    System.out.println("NOTE: a value of 0, less than 0 , or blank returns all search results.");
    if (clientPane.isTemplatesSupported())
        searchTemplateViewer.startSearch();
    else 
        searchPanel.startSearch();
}

private void showHelp() {
    client.displayHelp();
    cmbValidate();
}


/**
 * searchStarted is called when we receive the search started event
 * from the SearchTemplateViewer.  Need to keep button enablement in 
 * sync.
 */
private void searchStarted() {
// System.out.println("The thread in FunctionBar class startSearch method: " + Thread.currentThread());
  // make templates non-selectable while a search is on going.
  numberOfSearchResults=0;
  refreshStatusBar( ResourceMgr.getString( "SEARCHING"));
  disableButtons();
  cancelSearchButton.setEnabled(true);
  paintImmediately( this.getBounds());
  cmbValidate();
 }


/**
 * The search has completed
 */
private void searchIsDone() {
 refreshStatusBar(ResourceMgr.getString( "STATUS_BAR_SEARCH_COMPLETED", new Integer(numberOfSearchResults)));
 cancelSearchButton.setEnabled(false);
 enableButtons();
 cmbValidate();
}

/**
 * Validate the client
 */
private void cmbValidate ( ) {
 Component cp=getParent();
	 if (cp!=null) {
     	cp.invalidate();
   	cp.validate();
      cp.doLayout();
      cp.repaint();
	  }
  	return;
}


/**
 * Enable the function bar buttons
 */
public synchronized void enableButtons( ) {
      searchTemplateList.setEnabled(true);
      refreshTemplatesButton.setEnabled(true);
      searchButton.setEnabled(true);
      //cancelSearchButton.setEnabled(true);
      clearButton.setEnabled(true);
      resetDefaultsButton.setEnabled(true);
      helpButton.setEnabled(true);
      optionsButton.setEnabled(true);
	return;
}


private void refreshStatusBar(String s) {
   statusBar.setText(s);
   paintImmediately( this.getBounds());
   cmbValidate();
 return;
}

 /**
 * Disable buttons
 */
public synchronized void disableButtons( ) {
  searchButton.setEnabled(false);
  refreshTemplatesButton.setEnabled(false);
  cancelSearchButton.setEnabled(false);
  clearButton.setEnabled(false);
  resetDefaultsButton.setEnabled(false);
  optionsButton.setEnabled(false);
  searchTemplateList.setEnabled(false);
  helpButton.setEnabled(false);
  paintImmediately( this.getBounds());
  return;
}

/**
  * Verify button states after initialization in Client to check if
  * valid Federation Manager logon exists and if search templates are
  * available. Set button states accordingly.
  *
  **/
public void verifyButtonStates() {
   //Disable all if not logged on to Federation Manager connection
   if ( !(connection.isConnected()))  {
      disableButtons();
      helpButton.setEnabled(true);
   }
   //Disable the search and clear buttons if no templates/entities are available
   else {
    if (clientPane.isTemplatesSupported()) {
        refreshTemplatesButton.setVisible(true);    
    }
    else {
        refreshTemplatesButton.setVisible(false);    
    }
    if (searchTemplateViewer.isShowing()) {
        if (searchTemplateList.getSelectedTemplate() == null) {
            System.out.println("getselectedtemplate is null");
            disableButtons();
            refreshTemplatesButton.setEnabled(true);
            helpButton.setEnabled(true);
        }
        else {
            enableButtons();
        }
    }
    else {
        // Must be using search panel
        if (searchPanel.getEntity() == null) {
            System.out.println("getEntity is null");
            disableButtons();
            //refreshTemplatesButton.setEnabled(true);
            helpButton.setEnabled(true);
        }
        else {
            enableButtons();
            refreshTemplatesButton.setEnabled(false);
        }
    }
   }

 }


 public void onSearchStarted(CMBSearchStartedEvent evt) {
    this.searchStarted();
 }

 public void onSearchCompleted(CMBSearchCompletedEvent evt) {
       searchIsDone();  // search is done, flip buttons
       if (evt.isSuccess()==true ){
          refreshStatusBar( ResourceMgr.getString( "STATUS_BAR_SEARCH_COMPLETED", new Integer(numberOfSearchResults)));
       }
}

public void onDocumentOpened(CMBDocumentOpenedEvent evt) {
    CMBItem document=evt.getDocument();
    allDocumentsSelectedForViewing.removeElement(document);
    if (allDocumentsSelectedForViewing.isEmpty() ) {
     refreshStatusBar(ResourceMgr.getString( "STATUS_BAR_ITEMS_FOUND", new Integer(numberOfSearchResults)));
    }
}


public void onDocumentOpenFailed(CMBDocumentOpenFailedEvent evt) {
    CMBItem document=evt.getDocument();
    allDocumentsSelectedForViewing.removeElement(document);
    if (allDocumentsSelectedForViewing.isEmpty() ) {
     refreshStatusBar(ResourceMgr.getString( "STATUS_BAR_ITEMS_FOUND", new Integer(numberOfSearchResults)));
    }
}


/**
 * Listening to search results to monitor the status bar
 * with  the number of items in the search results viewer while results
 * are coming back .
 **/

public void onSearchResults(CMBSearchResultsEvent evt) {
   int currentResults=0;
   Vector v=evt.getResults();
   if (v!=null) {
      currentResults=v.size();
   }
     numberOfSearchResults= currentResults + numberOfSearchResults;
     System.out.println(" number of search results returned:   " + currentResults );
     refreshStatusBar( ResourceMgr.getString( "STATUS_BAR_TEMPLATE_SELECTED", new Integer(numberOfSearchResults)));
    return;
 }

 /**
    A document was selected for viewing
   */
public void onViewDocument(CMBViewDocumentEvent event) {
    //System.out.println(" about to view a document refresh status bar ");
    allDocumentsSelectedForViewing.addElement(event.getDocument());
    statusBar.setText(ResourceMgr.getString( "VIEW_DOC" ));
    cmbValidate();
}


    /** Invoked by the CMBSearchTemplateListView when a new template is selected
     *  Refresh the item count of results
    */
   public void onTemplateSelected(CMBTemplateSelectedEvent evt) {
      //CMBSearchTemplate selectedTemplate=evt.getSelectedTemplate();
      numberOfSearchResults=searchResultsViewer.getItemCount() ;
      //System.out.println(" on TemplateSelected ");
      refreshStatusBar( ResourceMgr.getString( "STATUS_BAR_TEMPLATE_SELECTED", new Integer(numberOfSearchResults)));
     }
    /** Invoked by the CMBSearchPanel when a new template is selected
     *  Refresh the item count of results
    */
   public void onEntitySelected(CMBEntitySelectedEvent evt) {
      numberOfSearchResults=searchResultsViewer.getItemCount() ;
      //System.out.println(" on EntitySelected ");
      refreshStatusBar( ResourceMgr.getString( "STATUS_BAR_TEMPLATE_SELECTED", new Integer(numberOfSearchResults)));
     }
    /** Invoked by the CMBLogonPanel when a logon is completed
     *  Refresh the visible butons
    */
   public void onLogonCompleted(CMBLogonCompletedEvent evt) {
      //System.out.println(" on LogonCompleted ");
      // Set button visibility 
      setButtonStates();
   }
   
   public void setButtonStates() {
      if (clientPane.isTemplatesSupported()) {
        refreshTemplatesButton.setVisible(true);
        //resetDefaultsButton.setVisible(true);
      } else {
        refreshTemplatesButton.setVisible(false);
        //resetDefaultsButton.setVisible(false);
      }
   }


}
