/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/
                                                        
// sample to list servers/ list schema / list schema attributes from DL

/*
 * Filename       : TListCatalog2DL.java
 * Description    : test DKDatastoreDL for list functions
 *
 */

import com.ibm.mm.sdk.common.*;
import com.ibm.mm.sdk.server.*;
import java.io.*;

// TListCatalog2DL class
public class TListCatalog2DL implements DKConstantDL {

  // Main method
  public static void main(String argv[]){
    
    // Indicate this is a Console Application on Windows NT/95 for error
    // message display in dos console code page. If this was a Windows
    // GUI (Graphic User Interface) Application this would not be necessary
    // because DK_CM_SS_WINDOWS is the default.
    DKEnvironment.setSubSystem(DK_CM_SS_CONSOLE);

    //-------------------------------------------------------------- 
    // Checking for input parameters
    //-------------------------------------------------------------- 
    if (argv.length < 3)
    {
       System.out.println("Invoke Syntax: " );
       System.out.println("  java TListCatalog2DL " +
        "<libsrv> <userid> <pw>" );
       return;
    }
    
    String libSrv = argv[0];
    String userid = argv[1];
    String pw = argv[2];
       
    DKDatastoreDL dsDL = null;
    try {
    DKSequentialCollection pCol = null;
    dkIterator pIter = null;
    DKSequentialCollection pCol2 = null;
    dkIterator pIter2 = null;
    DKServerDefDL pSV = null;
    String strServerName = null;
    String strServerType = null;
    String strIndexClass = null;
    DKDatastoreDefDL dsDef = null;
    DKIndexClassDefDL icDef = null;
    DKAttrDefDL attrDef = null;
    int i = 0;
    int j = 0;
    dsDL = new DKDatastoreDL();
    System.out.println("list servers");
    pCol = (DKSequentialCollection)dsDL.listDataSources();
    pIter = pCol.createIterator();
    while (pIter.more() == true)
    {
     i++;
     pSV = (DKServerDefDL)pIter.next();
     strServerName = pSV.getName();
     strServerType = pSV.getServerType();
     System.out.println("Server Name [" + i + "] - " + strServerName + " Server Type - " + strServerType);
    }
    System.out.println(i + " servers listed");
    System.out.println("connecting to datastore"); 
    dsDL.connect(libSrv,userid,pw,"");
    System.out.println("datastore connected libSrv " + libSrv + " userid " +
                        userid ); 
    System.out.println("list index classes");
    dsDef = (DKDatastoreDefDL)dsDL.datastoreDef();
    pCol = (DKSequentialCollection) dsDef.listEntities();
    pIter = pCol.createIterator();
    i = 0;
    while (pIter.more() == true)
    {
     i++;
     icDef = (DKIndexClassDefDL)pIter.next();
     strIndexClass = icDef.getName();
     System.out.println("index class name [" + i + "] - " + strIndexClass);
     System.out.println("  list attributes for " + strIndexClass + " index class");
     pCol2 = (DKSequentialCollection) dsDef.listEntityAttrs(strIndexClass);
     pIter2 = pCol2.createIterator();
     j = 0;
     while (pIter2.more() == true)
     {
      j++;
      attrDef = (DKAttrDefDL)pIter2.next();
      System.out.println("    Attribute name [" + j + "] - " + attrDef.getName());
      System.out.println("      datastoreType " + attrDef.datastoreType());
      System.out.println("      attributeOf " + attrDef.getEntityName());
      System.out.println("      type " + attrDef.getType());
      System.out.println("      size " + attrDef.getSize());
      System.out.println("      id " + attrDef.getId());
      System.out.println("      nullable " + attrDef.isNullable());
      System.out.println("      precision " + attrDef.getPrecision());
      System.out.println("      scale " + attrDef.getScale());
      System.out.println("      stringType " + attrDef.getStringType());
     }
     System.out.println("  " + j + " attributes listed for " + strIndexClass + " index class");
    }
    System.out.println(i + " index classes listed");
    dsDL.disconnect();
    System.out.println("datastore disconnected"); 
    dsDL.destroy();
    }
    catch(DKException exc)
    {
     try {
         dsDL.destroy();
     }
     catch (Exception e)
     {
      e.printStackTrace();
     }      
     System.out.println("Exception name " + exc.name());
     System.out.println("Exception message " + exc.getMessage());
     System.out.println("Exception error code " + exc.errorCode());
     System.out.println("Exception error state " + exc.errorState());
     exc.printStackTrace();
    }
    catch (Exception exc)
    {
     try {
         dsDL.destroy();
     }
     catch (Exception e)
     {
      e.printStackTrace();
     }      
     System.out.println("Exception message " + exc.getMessage());
     exc.printStackTrace();
    }
  }
}

