/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/
                         
// sample list items in WorkFlow/WorkBasket

/*
 * Filename : TListItemsWFS.java
 * Description : List items in WorkFlow/WorkBasket
 *
 */

import com.ibm.mm.sdk.common.*;
import com.ibm.mm.sdk.server.*;
import java.io.*;

public class TListItemsWFS
        implements DKConstant, DKMessageId
{
  //replace following with your library server name, userid, pasword
  public static final String STR_LIB_SERVER  = "LIBSRVRN";
  public static final String STR_USER_ID     = "FRNADMIN";
  public static final String STR_PASSWORD    = "PASSWORD";

  // Main method
  public static void main(String argv[])
  {
    System.out.println("begin...");
    
    DKDatastoreDL dsDL = null;
    try {
        dsDL = new DKDatastoreDL();
        DKWorkFlowServiceDL wfDL = new DKWorkFlowServiceDL(dsDL);
        System.out.println("Datastore DL created");
        System.out.println("connecting to datastore");
      	dsDL.connect(STR_LIB_SERVER, STR_USER_ID, STR_PASSWORD, "");
        System.out.println("datastore connected");
	    if (wfDL.isConnected())
	        System.out.println("workflow service has been connected");
	    else
	        System.out.println("workflow service is not connected");

        System.out.println("");
        System.out.println("*****************List of item in workflow");
        DKSequentialCollection wfList = (DKSequentialCollection)wfDL.listWorkFlows();
	    if (wfList != null)
        {
            dkIterator pIter = wfList.createIterator();
            while (pIter.more())
            {
                DKWorkFlowDL pwf1 = (DKWorkFlowDL)pIter.next(); 
                System.out.println("Workflow ID = " + pwf1.getID());
                DKSequentialCollection itemList = (DKSequentialCollection)pwf1.listItemIDs();
                if (itemList != null)
                {
                    dkIterator iter1 = itemList.createIterator();
                    String itemid;
                    System.out.println("There are " + itemList.cardinality()
                                    + " folders/documents defined in the workflow");
                    while (iter1.more())
                    {
                        itemid = (String)iter1.next();
                        System.out.println(" ------- Item ID = " + itemid);
                    }
                }
            }
        }

        System.out.println("");
        System.out.println("*****************List of work management info in workflow");
        DKSequentialCollection wfList2 = (DKSequentialCollection)wfDL.listWorkFlows();
	    if (wfList2 != null)
        {
            dkIterator pIter = wfList2.createIterator();
            while (pIter.more())
            {
               DKWorkFlowDL  pwf1 = (DKWorkFlowDL)pIter.next(); 
                System.out.println("Workflow ID = " + pwf1.getID());
                DKSequentialCollection itemList = (DKSequentialCollection)pwf1.listWorkManagementInfos();
                if (itemList != null)
                {
                    dkIterator iter1 = itemList.createIterator();
                    DKWorkManagementInfoDL wm;
                    System.out.println("There are " + itemList.cardinality()
                                    + " folders/documents defined in the workflow");
                    while (iter1.more())
                    {
                        wm = (DKWorkManagementInfoDL)iter1.next();
                        System.out.println(" ------ Item ID = " + wm.getItemID());
                        System.out.println("Suspension status " + wm.getSuspensionStatus());
                        System.out.println("WorkFlow status " + wm.getWorkFlowStatus());
                        System.out.println("Release Type " + wm.getReleaseType());
                        System.out.println("Priority " + wm.getPriority());
                        System.out.println("WorkFlow ID " + wm.getWorkFlowID());
                        System.out.println("WorkBasket ID " + wm.getWorkBasketID());
                        DKTimestamp tsval = wm.getWFEntry();
                        System.out.println("WFEntry -- Year: " + tsval.getYear()
                                            + " Month: " + tsval.getMonth()
                                            + " Day: " + tsval.getDate()
                                            + " Hours: " + tsval.getHours()
                                            + " Minutes: " + tsval.getMinutes()
                                            + " Seconds: " + tsval.getSeconds()
                                            + " Nanos: " + tsval.getNanos()
                                            );
                        tsval = wm.getWBEntry();
                        System.out.println("WBEntry -- Year: " + tsval.getYear()
                                            + " Month: " + tsval.getMonth()
                                            + " Day: " + tsval.getDate()
                                            + " Hours: " + tsval.getHours()
                                            + " Minutes: " + tsval.getMinutes()
                                            + " Seconds: " + tsval.getSeconds()
                                            + " Nanos: " + tsval.getNanos()
                                            );
                    }
                }
            }
        }

        dsDL.disconnect();
        System.out.println("datastore disconnected");
        dsDL.destroy();
    }
  
    catch(DKException exc)
    {
     try {
         dsDL.destroy();
     }
     catch (Exception e)
     {
      e.printStackTrace();
     }      
     System.out.println("Exception id " + exc.exceptionId());
     System.out.println("Exception Class Name: " + exc.name());
     System.out.println("Exception message " + exc.getMessage());
     System.out.println("Exception error code " + exc.errorCode());
     System.out.println("Exception error state " + exc.errorState());
     exc.printStackTrace();
    }
    catch (Exception exc)
    {
     try {
         dsDL.destroy();
     }
     catch (Exception e)
     {
      e.printStackTrace();
     }      
     System.out.println("Exception message " + exc.getMessage());
     exc.printStackTrace();
    }

    System.out.println("done ...");
  } // end of main    
}
