/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/

//**************************************************************************
// txdoaddfDL.java - Test DKBlobDL for add(fileName) 
// (this test case requires you to know the existing itemId in the library.)
//**************************************************************************
import com.ibm.mm.sdk.server.*;
import com.ibm.mm.sdk.common.*;
import java.io.*;
import java.lang.*;

public class txdoaddfDL
    implements DKConstantDL
{
  //replace following with your library server name, userid, pasword
  public static final String STR_LIB_SERVER  = "LIBSRVRN";
  public static final String STR_USER_ID     = "FRNADMIN";
  public static final String STR_PASSWORD    = "PASSWORD";

  // Main method
  public static void main(String args[])
  {
    // Indicate this is a Console Application on Windows NT/95 for error
    // message display in dos console code page. If this was a Windows
    // GUI (Graphic User Interface) Application this would not be necessary
    // because DK_CM_SS_WINDOWS is the default.
    DKEnvironment.setSubSystem(DK_CM_SS_CONSOLE);

    int    partId = 19;                        //partId 19 is not used yet
    String itemId = "K5#NLPETZ#TU2D$2";        //existing itemId
    String fileName = "e:\\dlv200j\\test\\china.gif"; //a Windows NT file for add

    if (args.length == 2)
    {
      partId = (int)Integer.parseInt(args[0], 10);
      itemId = args[1];
      System.out.println("You enter: java txdoaddfDL " +
       + partId + " " + itemId);
    }
    if (args.length == 1)
    {
      partId =(int)Integer.parseInt(args[0], 10);
      System.out.println("You enter: java txdoaddfDL " + partId );
      System.out.println("The supplied default itemId = " + itemId);
    }
    if (args.length == 0)
    {
      System.out.println("invoke: java txdoaddfDL <partId> <itemId>");
      System.out.println("No parameter, folldeowing defaults will be provided:");
      System.out.println("     default partId = " + partId);
      System.out.println("     default itemId = " + itemId);
    } 
    
    DKDatastoreDL dsDL = null;
    try {
         dsDL = new DKDatastoreDL(); //required datastore 
         dsDL.connect(STR_LIB_SERVER, STR_USER_ID, STR_PASSWORD, ""); //connect to datastore
         DKBlobDL axdo = new DKBlobDL(dsDL);      //create XDO
         DKPidXDODL  apid = new DKPidXDODL();     //create Pid
         apid.setPartId(partId);                  //set partId
         apid.setPrimaryId(itemId);               //set itemId 
         axdo.setPidObject(apid);                 //setPid to XDO
         axdo.setRepType("ABCD");                 //set representation type
         axdo.setContentClass(DK_DL_CC_GIF);      //set ContentClass
         axdo.add(fileName);                      //add from file 
         dsDL.disconnect();                       //disconnect from datastore
         dsDL.destroy();
    } //end of try

    catch (DKException exc)
    {
     try {
         dsDL.destroy();
     }
     catch (Exception e)
     {
      e.printStackTrace();
     }      
     System.out.println("Exception name " + exc.name());
     System.out.println("Exception message " + exc.getMessage());
     exc.printStackTrace();
    }
    catch (Exception exc)
    {
     try {
         dsDL.destroy();
     }
     catch (Exception e)
     {
      e.printStackTrace();
     }      
     System.out.println("Exception message " + exc.getMessage());
     exc.printStackTrace();
    }  
  }
}

