/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/

// test list servers/ list schema / list schema attributes from OD

/*
 * Filename       : TClientListFoldersOD.java
 * Description    : test DKDatastoreOD for list functions
 * Change History :
 *
 * Date        Name  Description
 * -------    -----  ---------------------------
 * 2002/04/21  nnc   Creation of test cases
 *
 */

import com.ibm.mm.sdk.common.*;
import com.ibm.mm.sdk.client.*;
import java.io.*;

// TListFolders class
public class TClientListFoldersOD implements DKConstantOD
{

  // Main method
  public static void main(String argv[])
  {
    // Indicate this is a Console Application on Windows NT/95 for error
    // message display in dos console code page. If this was a Windows
    // GUI (Graphic User Interface) Application this would not be necessary
    // because DK_CM_SS_WINDOWS is the default.
    DKEnvironment.setSubSystem(DK_CM_SS_CONSOLE);

    String libSrv = new String("");   // libserver
    String userid = new String("");   // userid
    String pw = new String("");   // pw
    String connect_string = new String("");
    String configuration_string = new String("");

    DKDatastoreOD dsOD = null;

    //--------------------------------------------------------------
    // Checking for input parameters
    //--------------------------------------------------------------
    if (argv.length < 1)
    {
      System.out.println("Invoke Syntax: " );
      System.out.println("  java TClientListFoldersOD " +
                         "<libsrv> <userid> <pw> " +
                         "<connect string> <configuration string>" );
      return;
    }
    else
    {
      libSrv = argv[0];
      userid = argv[1];
      pw = argv[2];
      if (argv.length > 3)
        connect_string = argv[3];
      if (argv.length > 4)
        configuration_string = argv[4];
    }
    System.out.println("connection string=>" + connect_string + "<=");
    System.out.println("configuration string=>" + configuration_string + "<=");

    try
    {
      if (configuration_string.length() > 0)
      {
        dsOD = new DKDatastoreOD(configuration_string);
      }
      else
      {
        dsOD = new DKDatastoreOD();
      }
      DKSequentialCollection pCol = null;
      dkIterator pIter = null;
      DKSequentialCollection pCol2 = null;
      dkIterator pIter2 = null;
      DKServerDefOD pSV = null;
      String strServerName = null;
      String strServerType = null;
      DKDatastoreDefOD dsDef = null;
      String folderName;
      int i = 0;
      int j = 0;
      System.out.println("list servers");
      pCol = (DKSequentialCollection)dsOD.listDataSources();
      pIter = pCol.createIterator();
      while (pIter.more() == true)
      {
        i++;
        pSV = (DKServerDefOD)pIter.next();
        strServerName = pSV.getName();
        strServerType = pSV.getServerType();
        System.out.println("Server Name [" + i + "] - " + strServerName + " Server Type - " + strServerType);
      }
      System.out.println(i + " servers listed");
      System.out.println("connecting to datastore");
      dsOD.connect(libSrv,userid,pw,connect_string);
      System.out.println("datastore connected libSrv " + libSrv + " userid " +
                         userid );
      System.out.println("list folders");
      dsDef = (DKDatastoreDefOD)dsOD.datastoreDef();

      String[] folderNames;
      folderNames = dsDef.listSearchTemplateNames();
      for (i = 0; folderNames!=null && i < folderNames.length; i++)
      {
        System.out.println("folder name #" + (i+1) + " - " + folderNames[i]);
      }

      System.out.println(i + " folders listed");
      dsOD.disconnect();
      System.out.println("datastore disconnected");

      dsOD.destroy(); // Finished with the datstore
    }
    catch (DKException exc)
    {
      System.out.println("Exception name " + exc.name());
      System.out.println("Exception message " + exc.getMessage());
      exc.printStackTrace();
    }
    catch (Exception exc)
    {
      System.out.println("Exception message " + exc.getMessage());
      exc.printStackTrace();
    }
  }
}

