<!--
@copyright(disclaimer)
Licensed Materials - Property of IBM
IBM  Enterprise Information Portal  for Multiplatforms V8.1  (program number 5724-B43)
(c) Copyright IBM Corp. 1998,  2002. All Rights Reserved.

US Government Users Restricted Rights
Use, duplication or disclosure restricted by GSA ADP Schedule
Contract with IBM Corp.

DISCLAIMER OF WARRANTIES :

Permission is granted to copy and modify this  Sample code, and to
distribute modified versions provided that both the copyright
notice,- and this permission notice and warranty disclaimer  appear in all copies and modified
versions.

THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.
IBM  AND ITS SUPPLIERS AND LICENSORS  DISCLAIM
ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY
OF NON-INFRINGEMENT AND THE IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
PARTICULAR PURPOSE. IN NO EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY
DAMAGES ARISING OUT OF THE USE OF  OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF
THE SAMPLE CODE, OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL
IBM OR ITS LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA,
OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS LICENSORS OR SUPPLIERS
HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

@endCopyright
-->

<%@ page info="frameset for document viewer"
         language="java"
         import="com.ibm.mm.beans.*,
                 com.ibm.mm.viewer.*,
                 com.ibm.mm.servlets.*,
                 java.net.URLEncoder" 
%>
<jsp:useBean id="idtodocmap" scope="session" type="java.util.Hashtable"/>

<%
    
    String itemId = request.getParameter("itemId");
    
    if (itemId == null || itemId.equals("")) {
        throw new RuntimeException("The itemId parameter is not specified");
    }
    CMBDocument document = (CMBDocument) idtodocmap.get(itemId);
    if (document == null) {
      throw new IllegalArgumentException(ServletUtils.getMessage(CMBServletConstants.RESOURCE_BASE_NAME, "CMBServlet.InvalidItemId", new String[] {itemId}));
    }

    String pagenum="1"; // display first page when viewframe.jsp is loaded.
    if (request.getParameter("page") != null && request.getParameter("page").length() > 0) {
        pagenum=request.getParameter("page");
    }

    String scale=new Double(document.getPreferredScale()).toString();
    if (request.getParameter("scale") != null && request.getParameter("scale").length() > 0) {
        scale=request.getParameter("scale");
    }

    String rotation=new Integer(document.getRotation()).toString();
    if (request.getParameter("rotation") != null && request.getParameter("rotation").length() > 0) {
        rotation=request.getParameter("rotation");
    }

    String annotations = (new Boolean(document.getShowAnnotations())).toString();
    if (request.getParameter("annotations") != null && request.getParameter("annotations").length() > 0) {
        annotations=request.getParameter("annotations");
    }

    String parameters = "itemId="+URLEncoder.encode(itemId)
                        +"&page="+URLEncoder.encode(pagenum)
                        +"&scale="+URLEncoder.encode(scale)
                        +"&rotation="+URLEncoder.encode(rotation)
                        +"&annotations="+URLEncoder.encode(annotations);

    String reply = URLEncoder.encode("/jsp/servlets/viewtoolbar.jsp");
%>

<html>

<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<title>IBM Enterprise Information Portal Servlets Sample</title>
</head>

<!--viewPage action is used in the frameset to retrieve a page of the document-->
<frameset rows="40,*" frameborder="no" border=0>

  <frame frameborder=no name="viewtoolbar" marginwidth="1" marginheight="0" scrolling="auto"
         src="<%= response.encodeURL("CMBControlServlet?reply="+reply+"&"+parameters) %>">
  </frame>

  <frame frameborder=no name="viewpage" marginwidth="10" marginheight="10" scrolling="auto"
         src="<%= response.encodeURL("CMBControlServlet?action=viewPage&"+parameters) %>">
  </frame>

  <noframes>
    <body>
      <h2>Frame Alert</h2>
      <p>
      This document is designed to be viewed using the frames feature. If
      you see this message, you are using a non-frame-capable web browser.
      <br><br><br>
      viewframe.jsp
    </body>
  </noframes>

</frameset>
</html>
